;***********************************************************************************************************
;   CR_RX_15C_PROG_V5_ASM
;
;
;   RECEPTOR RF PARA CONTROLE REMOTOS  15 CANAIS
; 
;   PARA RECEPO UTILIZA UM PIC 16F628A
;   BLOG: 'LARIOS.TECNOLOGIA.WS'
;   PODE SER CONFIGURADO O MODO DE SAIDA DE CADA CANAL P/ PULSO OU RETENO
;
;   CLAUDIO LRIOS        INICIO: 27-01-2016  TERMINO:27-01-2016
;   
;***********************************************************************************************************
;   CONTROLA AT 15 RELES DE SAIDA, COM OPERAO PULSO OU RETENO NAS SADAS DE FORMA INDIVIDUAL
;   OBS. ESCOLHA DO MODO RETENO OU PULSO DEVE SER FEITA NA OCASIO DA COMPILAO DESTE ARQUIVO.
;   TRABALHA EM CONJUNTO COM O TX DE CDIGO ASM: TX_CR_15CPROG_ASM
;   
;*********************************************************************************************************** 


SERIAL_NUMBER   EQU  0XAA     ;ESCOLHA AQUI O NUMERO DO RECEPTOR (TEM QUE SER IGUAL DO TX)
;===========================================================================================================
;ESCOLHA O MODO DE OPERAO DAS SADAS DE FORMA INDIVIDUAL
;COMENTE PARA 'PULSO' E DESCOMENTE PARA 'RETENO'

;#DEFINE  CANAL1_RET   ; SAIDA DO LED 7 (PINO 6 RB0) EM MODO DE RETENO 
;#DEFINE  CANAL2_RET   ; SAIDA DO LED 6 (PINO 7 RB1) EM MODO DE RETENO 
;#DEFINE  CANAL3_RET   ; SAIDA DO LED 5 (PINO 8 RB2) EM MODO DE RETENO 
;#DEFINE  CANAL4_RET   ; SAIDA DO LED 4 (PINO 9 RB3) EM MODO DE RETENO 
;#DEFINE  CANAL5_RET   ; SAIDA DO LED 3 (PINO 10 RB4) EM MODO DE RETENO 
;#DEFINE  CANAL6_RET   ; SAIDA DO LED 2 (PINO 11 RB5) EM MODO DE RETENO 
;#DEFINE  CANAL7_RET   ; SAIDA DO LED 1 (PINO 12 RB6) EM MODO DE RETENO 
;#DEFINE  CANAL8_RET   ; SAIDA DO LED 0 (PINO 13 RB7) EM MODO DE RETENO 

;#DEFINE  CANAL9_RET   ; SAIDA DO LED  8 (PINO 17 RA0) EM MODO DE RETENO 
;#DEFINE  CANAL10_RET   ; SAIDA DO LED 9 (PINO 18 RA1) EM MODO DE RETENO 
;#DEFINE  CANAL11_RET   ; SAIDA DO LED 10 (PINO 1 RA2) EM MODO DE RETENO 
;#DEFINE  CANAL12_RET   ; SAIDA DO LED 11 (PINO 2 RA3) EM MODO DE RETENO 
;#DEFINE  CANAL13_RET   ; SAIDA DO LED 12 (PINO 3 RA4) EM MODO DE RETENO 
;#DEFINE  CANAL14_RET   ; SAIDA DO LED 13 (PINO 15 RA6) EM MODO DE RETENO 
;#DEFINE  CANAL15_RET   ; SAIDA DO LED 14 (PINO 16 RA7) EM MODO DE RETENO 


;===========================================================================================================

 	LIST P=16F628A , R=DEC

 	INCLUDE "P16F628A.INC"
;--------------------------
	ERRORLEVEL      -302    ;ELIMINA MENSAGEM DE ERRO

;PALAVRA DE CONFIGURAO
	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT & _BODEN_ON & _MCLRE_OFF & _LVP_OFF 

;DEFINES
#DEFINE		BANK0	BCF	STATUS,RP0 	 ;SETA BANK0 DE MEMORIA
#DEFINE		BANK1	BSF	STATUS,RP0	 ;SETA BANK1
#DEFINE		FLAG	FLAGS,0          ;FLAG DE SITUAO
#DEFINE 	SIN 	PORTA,5  		 ;PINO 4  IN RF  (RECEBE SINAL DO RECEPTOR DE RADIO FREQUENCIA)

#DEFINE     FLAG_TOK1  FLAGS1,0      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK2  FLAGS1,1      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK3  FLAGS1,2      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK4  FLAGS1,3      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK5  FLAGS1,4      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK6  FLAGS1,5      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK7  FLAGS1,6      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK8  FLAGS1,7      ;FLAG HABILITADOR DE INVERSO DE SAIDA 

#DEFINE     FLAG_TOK9  FLAGS2,0      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK10  FLAGS2,1      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK11  FLAGS2,2      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK12  FLAGS2,3      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK13  FLAGS2,4      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK14  FLAGS2,5      ;FLAG HABILITADOR DE INVERSO DE SAIDA 
#DEFINE     FLAG_TOK15  FLAGS2,6      ;FLAG HABILITADOR DE INVERSO DE SAIDA 

;RAM
     CBLOCK  0X20
 RES3,RES2,RES1,RES0,FLAGS,BITCOUNTER,LC,HC,CONT,R0,R1,R2,NOTX,NOTX1,AUX,FLAGS1,FLAGS2
 NOTX1C1,NOTXC1,NOTX1C2,NOTXC2,NOTX1C3,NOTXC3,NOTX1C4,NOTXC4,NOTX1C5,NOTXC5
 NOTX1C6,NOTXC6,NOTX1C7,NOTXC7,NOTX1C8,NOTXC8,TMP,TMP1,TMPX,TMP1X
 NOTX1C9,NOTXC9,NOTX1C10,NOTXC10,NOTX1C11,NOTXC11,NOTX1C12,NOTXC12,NOTX1C13,NOTXC13
 NOTX1C14,NOTXC14,NOTX1C15,NOTXC15
     ENDC

;EQUATES
TMAX    EQU  .50       ;TEMPO MAXIMO DO SINAL LOW
QBYTE   EQU  .32        ;QUANTIDADE DE BITS A SER RECEBIDO 
VNOTX   EQU  .15       ; TEMPO ENTRE APERTOS DOS BOTES PARA ACEITAO DE MUDANA DA SADA 
;================================================================================================================



;=================================================================================================================
;                     INICIO DO PROGRAMA
;=================================================================================================================
    ORG 0X00
    GOTO START

    ORG 0X04
    RETFIE
;=================================================================================================================
;                     INICIALIZAES DE PORTAS E REGISTRADORES
;=================================================================================================================
START:
	MOVLW   0X07
	MOVWF	CMCON			;DESLIGA COMPARADORES
	MOVLW   .0
    MOVWF   PORTA
    MOVWF   PORTB
    BANK1
    MOVLW   B'00000000'  ;TUDO SAIDA
    MOVWF   TRISB
    MOVLW   B'00100000'  ;SAIDAS + IN_RF PINO 4 (RA5)
    MOVWF   TRISA
    BANK0
    CLRF   FLAGS   ;APAGA REGISTRADOR DE FLAGS
    CLRF   FLAGS1
    CLRF   FLAGS2
    MOVLW  .0
    CALL   EEREAD
    MOVWF  TMP    ;SITUAO DAS SADAS EM MODO RETENO
    MOVWF  TMP1   ;CPIA

    MOVLW  .1
    CALL   EEREAD
    MOVWF  TMPX    ;SITUAO DAS SADAS EM MODO RETENO
    MOVWF  TMP1X   ;CPIA

    IFDEF  CANAL1_RET
    MOVFW  TMP
    ANDLW  .1
    BTFSS STATUS,Z
    BSF   PORTB,0
    ENDIF

    IFDEF  CANAL2_RET
    MOVFW  TMP
    ANDLW  .2
    BTFSS STATUS,Z
    BSF   PORTB,1
    ENDIF

    IFDEF  CANAL3_RET
    MOVFW  TMP
    ANDLW  .4
    BTFSS STATUS,Z
    BSF   PORTB,2
    ENDIF

    IFDEF  CANAL4_RET
    MOVFW  TMP
    ANDLW  .8
    BTFSS STATUS,Z
    BSF   PORTB,3
    ENDIF

    IFDEF  CANAL5_RET
    MOVFW  TMP
    ANDLW  .16
    BTFSS STATUS,Z
    BSF   PORTB,4
    ENDIF

    IFDEF  CANAL6_RET
    MOVFW  TMP
    ANDLW  .32
    BTFSS STATUS,Z
    BSF   PORTB,5
    ENDIF

    IFDEF  CANAL7_RET
    MOVFW  TMP
    ANDLW  .64
    BTFSS STATUS,Z
    BSF   PORTB,6
    ENDIF

    IFDEF  CANAL8_RET
    MOVFW  TMP
    ANDLW  .128
    BTFSS STATUS,Z
    BSF   PORTB,7
    ENDIF

   IFDEF  CANAL9_RET
    MOVFW  TMPX
    ANDLW  .1
    BTFSS STATUS,Z
    BSF   PORTA,0
    ENDIF

    IFDEF  CANAL10_RET
    MOVFW  TMPX
    ANDLW  .2
    BTFSS STATUS,Z
    BSF   PORTA,1
    ENDIF

    IFDEF  CANAL11_RET
    MOVFW  TMPX
    ANDLW  .4
    BTFSS STATUS,Z
    BSF   PORTA,2
    ENDIF

    IFDEF  CANAL12_RET
    MOVFW  TMPX
    ANDLW  .8
    BTFSS STATUS,Z
    BSF   PORTA,3
    ENDIF

    IFDEF  CANAL13_RET
    MOVFW  TMPX
    ANDLW  .16
    BTFSS STATUS,Z
    BSF   PORTA,4
    ENDIF

    IFDEF  CANAL14_RET
    MOVFW  TMPX
    ANDLW  .64
    BTFSS STATUS,Z
    BSF   PORTA,6
    ENDIF

    IFDEF  CANAL15_RET
    MOVFW  TMPX
    ANDLW  .128
    BTFSS STATUS,Z
    BSF   PORTA,7
    ENDIF

;=================================================================================================================
;                     LOOP PRINCIPAL
;=================================================================================================================
INICIO:
     
     CLRF  RES3
     CLRF  RES2
     CLRF  RES1
	 CLRF  RES0
     MOVLW  QBYTE  ;PREPARA PARA A RECEPO COM NUMERO DE BITS A RECEBER
	 MOVWF  BITCOUNTER
;=================================================================================================================
;                     RECEPO DE SINAL DE TX
;=================================================================================================================
L0
     BCF   FLAG   ;LIMPA FLAG E REGISTRADORES DE RECEPO
     CLRF  HC
     CLRF  LC
L1
L1H    
SS5:
     BTFSS FLAG        ;TESTA FLAG DE HUM/ZERO RECEBIDO
	 GOTO  L2      ;FLAG=0
     BTFSS SIN      ;SIN ? TESTA SINAL DE ENTRADA DO RECEPTOR DE RF
	 GOTO  M0       ; SIN=0
L2
	 BTFSS SIN      ;SIN ?
     GOTO  LA1      ;SIN=0
	 BSF   FLAG     ;SIN=1
     INCF  HC,F
     BTFSC STATUS,Z
     DECF  HC,F
     GOTO  LA2	   ;VAI CONTAR TEMPO DE 50 MICRO SEGUNDOS
LA1
    INCF  LC,F     ;INCREMENTA REGISTRADOR DE LOW SIGNAL NA ENTRADA RF
    BTFSC STATUS,Z
    DECF  LC,F
LA2
 	MOVLW  .11  ;.11 = 50 MICROSEG    (ACERTA TEMPO ENTRE LEITURAS DA ENTRADA DE RF)
    MOVWF  CONT
    DECFSZ CONT,F
    GOTO $-1

;CANAL1  LED7
    DECFSZ NOTXC1,F  ;MODO PULSO
    GOTO   PULA1
    DECFSZ NOTX1C1,F
    GOTO   PULA1
    IFNDEF  CANAL1_RET
    BCF    PORTB,0   ;DESLIGA CANAL 1 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK1   ;APAGA FLAG
    ENDIF
PULA1

;CANAL2  LED6
    DECFSZ NOTXC2,F  ;MODO PULSO
    GOTO   PULA2
    DECFSZ NOTX1C2,F
    GOTO   PULA2
    IFNDEF  CANAL2_RET
    BCF    PORTB,1   ;DESLIGA CANAL 2 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK2   ;APAGA FLAG
    ENDIF
PULA2
;CANAL3  LED5
    DECFSZ NOTXC3,F  ;MODO PULSO
    GOTO   PULA3
    DECFSZ NOTX1C3,F
    GOTO   PULA3
    IFNDEF  CANAL3_RET
    BCF    PORTB,2   ;DESLIGA CANAL 3 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK3   ;APAGA FLAG
    ENDIF
PULA3
   
;CANAL4  LED4
    DECFSZ NOTXC4,F  ;MODO PULSO
    GOTO   PULA4
    DECFSZ NOTX1C4,F
    GOTO   PULA4
    IFNDEF  CANAL4_RET
    BCF    PORTB,3   ;DESLIGA CANAL 4 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK4   ;APAGA FLAG
    ENDIF
PULA4

;CANAL5  LED3
    DECFSZ NOTXC5,F  ;MODO PULSO
    GOTO   PULA5
    DECFSZ NOTX1C5,F
    GOTO   PULA5
    IFNDEF  CANAL5_RET
    BCF    PORTB,4   ;DESLIGA CANAL 5 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK5   ;APAGA FLAG
    ENDIF
PULA5
;CANAL6  LED2
    DECFSZ NOTXC6,F  ;MODO PULSO
    GOTO   PULA6
    DECFSZ NOTX1C6,F
    GOTO   PULA6
    IFNDEF  CANAL6_RET
    BCF    PORTB,5   ;DESLIGA CANAL 6 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK6   ;APAGA FLAG
    ENDIF
PULA6
;CANAL7  LED1
    DECFSZ NOTXC7,F  ;MODO PULSO
    GOTO   PULA7
    DECFSZ NOTX1C7,F
    GOTO   PULA7
    IFNDEF  CANAL7_RET
    BCF    PORTB,6   ;DESLIGA CANAL 7 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK7   ;APAGA FLAG
    ENDIF
PULA7
;CANAL8  LED0
    DECFSZ NOTXC8,F  ;MODO PULSO
    GOTO   PULA8
    DECFSZ NOTX1C8,F
    GOTO   PULA8
    IFNDEF  CANAL8_RET
    BCF    PORTB,7   ;DESLIGA CANAL 8 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK8   ;APAGA FLAG
    ENDIF

PULA8




;CANAL15  LED14
    DECFSZ NOTXC15,F  ;MODO PULSO
    GOTO   PULA1S
    DECFSZ NOTX1C15,F
    GOTO   PULA1S
    IFNDEF  CANAL15_RET
    BCF    PORTA,7   ;DESLIGA CANAL 1 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK15   ;APAGA FLAG
    ENDIF
PULA1S

;CANAL14  LED13
    DECFSZ NOTXC14,F  ;MODO PULSO
    GOTO   PULA2S
    DECFSZ NOTX1C14,F
    GOTO   PULA2S
    IFNDEF  CANAL14_RET
    BCF    PORTA,6   ;DESLIGA CANAL 2 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK14   ;APAGA FLAG
    ENDIF
PULA2S
;CANAL13  LED12
    DECFSZ NOTXC13,F  ;MODO PULSO
    GOTO   PULA3S
    DECFSZ NOTX1C13,F
    GOTO   PULA3S
    IFNDEF  CANAL13_RET
    BCF    PORTA,4   ;DESLIGA CANAL 3 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK13   ;APAGA FLAG
    ENDIF
PULA3S
   
;CANAL12  LED11
    DECFSZ NOTXC12,F  ;MODO PULSO
    GOTO   PULA4S
    DECFSZ NOTX1C12,F
    GOTO   PULA4S
    IFNDEF  CANAL12_RET
    BCF    PORTA,3   ;DESLIGA CANAL 4 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK12   ;APAGA FLAG
    ENDIF
PULA4S

;CANAL11  LED10
    DECFSZ NOTXC11,F  ;MODO PULSO
    GOTO   PULA5S
    DECFSZ NOTX1C11,F
    GOTO   PULA5S
    IFNDEF  CANAL11_RET
    BCF    PORTA,2   ;DESLIGA CANAL 5 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK11   ;APAGA FLAG
    ENDIF
PULA5S
;CANAL10  LED9
    DECFSZ NOTXC10,F  ;MODO PULSO
    GOTO   PULA6S
    DECFSZ NOTX1C10,F
    GOTO   PULA6S
    IFNDEF  CANAL10_RET
    BCF    PORTA,1   ;DESLIGA CANAL 6 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK10   ;APAGA FLAG
    ENDIF
PULA6S
;CANAL9  LED8
    DECFSZ NOTXC9,F  ;MODO PULSO
    GOTO   PULA7S
    DECFSZ NOTX1C9,F
    GOTO   PULA7S
    IFNDEF  CANAL9_RET
    BCF    PORTA,0   ;DESLIGA CANAL 7 POR TEMPO EM MODO PULSO
    ELSE
    BCF    FLAG_TOK9   ;APAGA FLAG
    ENDIF
PULA7S
    GOTO L1
M0
    MOVFW  LC		    ;TESTA SE NO PASSOU DO LIMITE MAXIMO DE TEMPO EM LOW NA ENTRADA DE RF
    SUBLW  TMAX
    BTFSS  STATUS,C
    GOTO   INICIO       ;C=0 (-)  -  LC>TMAX (REJEITAR DADO - PAUSA INICIAL)
    MOVFW  HC			;OBTEM O VALOR DE 'CARRY'(HUM OU ZERO)
    SUBWF  LC,W
    RRF    RES3,F
    RRF    RES2,F
    RRF    RES1,F       ;DESLOCA  O BIT NOS REGISTRADORES DE RESULTADO
    RRF    RES0,F
      
    DECFSZ  BITCOUNTER,F  ;DECREMENTA O CONTADOR DE BITS A SER RECEBIDO
    GOTO   L0             ;LE PROXIMO BIT
;===========================================================================================================
;              TESTA A INTEGRIDADE DA TRANSMISSO SOMANDO RES0 A RES2 E COMPARANDO COM RES3
;===========================================================================================================

    MOVFW  RES0
    ADDWF  RES1,W
    ADDWF  RES2,W
    XORWF  RES3,W
    BTFSS  STATUS,Z
    GOTO   INICIO	  ;ERRO DE INTEGRIDADE NA RECEPO
;===========================================================================================================
;             TRANSMISSO FOI INTEGRA -  VERIFICAR SE   O NOSSO TX
;===========================================================================================================

    MOVLW   SERIAL_NUMBER    ;CODIGO DO NOSSO TRANSMISSOR
    XORWF   RES0,W
    BTFSS   STATUS,Z
    GOTO INICIO       ;NO  O NOSSO TRANSMISSOR, VOLTA AO INICIO
    COMF   RES1,F
    COMF   RES2,F     ;COMPLEMENTA A SAIDA
xd    
 	CALL   ACIONAR
    GOTO INICIO
  

;============================================================================================================
;            SUBTROTINAS
;============================================================================================================
ACIONAR
    MOVLW .0    ;LE ENDEREO '0' DA EEPROM
    CALL  EEREAD
    MOVWF  TMP  ;SALVA EM TMP
    MOVWF  TMP1 ;COPIA

    MOVLW .1    ;LE ENDEREO '0' DA EEPROM
    CALL  EEREAD
    MOVWF  TMPX  ;SALVA EM TMP
    MOVWF  TMP1X ;COPIA



;CANAL1 LED 7
    IFDEF   CANAL1_RET
    BTFSS  RES2,0
    GOTO   J3         ;    estava J3C1  
    BTFSC  FLAG_TOK1     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1      ;     estava J3 
    BTFSC  PORTB,0     ;INVERTE CANAL 7 EM MODO RETENO
    GOTO   J2
    BSF    PORTB,0
    BSF    TMP1,0
    GOTO   J1
J2  BCF    PORTB,0
    BCF    TMP1,0
J1  BSF    FLAG_TOK1
J3C1 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC1
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C1
J3
    ELSE
    BTFSC  RES2,0     ;ACIONA CANAL 1 EM MODO PULSO
    BSF    PORTB,0
    BTFSS  RES2,0
    BCF    PORTB,0
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC1
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C1

    ENDIF



;CANAL2 LED6

    IFDEF   CANAL2_RET
    BTFSS  RES2,1
    GOTO   J3Q           ;estava J3C1Q  
    BTFSC  FLAG_TOK2     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1Q         ;estava J3Q
    BTFSC  PORTB,1     ;INVERTE CANAL 2 EM MODO RETENO
    GOTO   J2Q
    BSF    PORTB,1
    BSF    TMP1,1
    GOTO   J1Q
J2Q  BCF    PORTB,1
    BCF    TMP1,1
J1Q  BSF    FLAG_TOK2
J3C1Q 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC2
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C2
J3Q
    ELSE
    BTFSC  RES2,1     ;ACIONA CANAL 2 EM MODO PULSO
    BSF    PORTB,1
    BTFSS  RES2,1
    BCF    PORTB,1
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC2
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C2
    ENDIF
;CANAL3  LED5
    IFDEF   CANAL3_RET
    BTFSS  RES2,2
    GOTO   J3W  
    BTFSC  FLAG_TOK3     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1W

    BTFSC  PORTB,2     ;INVERTE CANAL 3 EM MODO RETENO
    GOTO   J2W
    BSF    PORTB,2
    BSF    TMP1,2
    GOTO   J1W
J2W  BCF    PORTB,2
    BCF    TMP1,2
J1W  BSF    FLAG_TOK3
J3C1W 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC3
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C3
J3W
    ELSE
    BTFSC  RES2,2     ;ACIONA CANAL 3 EM MODO PULSO
    BSF    PORTB,2
    BTFSS  RES2,2
    BCF    PORTB,2
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC3
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C3
    ENDIF
;CANAL4  LED4
    IFDEF   CANAL4_RET
    BTFSS  RES2,3
    GOTO   J3E  
    BTFSC  FLAG_TOK4     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1E
    BTFSC  PORTB,3     ;INVERTE CANAL 4 EM MODO RETENO
    GOTO   J2E
    BSF    PORTB,3
    BSF    TMP1,3
    GOTO   J1E
J2E  BCF    PORTB,3
    BCF    TMP1,3
J1E  BSF    FLAG_TOK4
J3C1E 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC4
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C4
J3E
    ELSE
    BTFSC  RES2,3     ;ACIONA CANAL 4 EM MODO PULSO
    BSF    PORTB,3
    BTFSS  RES2,3
    BCF    PORTB,3
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC4
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C4
    ENDIF
;CANAL5  LED3
    IFDEF   CANAL5_RET
    BTFSS  RES2,4
    GOTO   J3R  
    BTFSC  FLAG_TOK5     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1R
    BTFSC  PORTB,4     ;INVERTE CANAL 5 EM MODO RETENO
    GOTO   J2R
    BSF    PORTB,4
    BSF    TMP1,4
    GOTO   J1R
J2R  BCF    PORTB,4
    BCF    TMP1,4
J1R  BSF    FLAG_TOK5
J3C1R 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC5
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C5
J3R
    ELSE
    BTFSC  RES2,4     ;ACIONA CANAL 5 EM MODO PULSO
    BSF    PORTB,4
    BTFSS  RES2,4
    BCF    PORTB,4
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC5
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C5
    ENDIF
 
;CANAL6   LED2
    IFDEF   CANAL6_RET
    BTFSS  RES2,5
    GOTO   J3T  
    BTFSC  FLAG_TOK6     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1T
    BTFSC  PORTB,5     ;INVERTE CANAL 6 EM MODO RETENO
    GOTO   J2T
    BSF    PORTB,5
    BSF    TMP1,5
    GOTO   J1T
J2T  BCF    PORTB,5
    BCF    TMP1,5
J1T  BSF    FLAG_TOK6
J3C1T 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC6
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C6
J3T
    ELSE
    BTFSC  RES2,5     ;ACIONA CANAL 6 EM MODO PULSO
    BSF    PORTB,5
    BTFSS  RES2,5
    BCF    PORTB,5
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC6
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C6
    ENDIF

;CANAL7   LED1
    IFDEF   CANAL7_RET
    BTFSS  RES2,6
    GOTO   J3Y  
    BTFSC  FLAG_TOK7     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1Y
    BTFSC  PORTB,6     ;INVERTE CANAL 7 EM MODO RETENO
    GOTO   J2Y
    BSF    PORTB,6
    BSF    TMP1,6
    GOTO   J1Y
J2Y  BCF    PORTB,6
    BCF    TMP1,6
J1Y  BSF    FLAG_TOK7
J3C1Y 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC7
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C7
J3Y
    ELSE
    BTFSC  RES2,6     ;ACIONA CANAL 7 EM MODO PULSO
    BSF    PORTB,6
    BTFSS  RES2,6
    BCF    PORTB,6
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC7
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C7
    ENDIF


;CANAL8   LED0
    IFDEF   CANAL8_RET
    BTFSS  RES2,7
    GOTO   J3U 
    BTFSC  FLAG_TOK8     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1U 
    BTFSC  PORTB,7     ;INVERTE CANAL 8 EM MODO RETENO
    GOTO   J2U
    BSF    PORTB,7
    BSF    TMP1,7
    GOTO   J1U
J2U  BCF    PORTB,7
    BCF    TMP1,7
J1U  BSF    FLAG_TOK8
J3C1U 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC8
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C8
J3U
    ELSE
    BTFSC  RES2,7     ;ACIONA CANAL 8 EM MODO PULSO
    BSF    PORTB,7
    BTFSS  RES2,7
    BCF    PORTB,7
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC8
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C8
    ENDIF


;CANAL15 LED 14
    IFDEF   CANAL15_RET
    BTFSS  RES1,7
    GOTO   J3H         ;    estava J3C1  
    BTFSC  FLAG_TOK15     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1H      ;     estava J3 
    BTFSC  PORTA,7     ;INVERTE CANAL 7 EM MODO RETENO
    GOTO   J2H
    BSF    PORTA,7
    BSF    TMP1X,7
    GOTO   J1H
J2H  BCF    PORTA,7
    BCF    TMP1X,7
J1H  BSF    FLAG_TOK15
J3C1H 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC15
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C15
J3H
    ELSE
    BTFSC  RES1,7     ;ACIONA CANAL 1 EM MODO PULSO
    BSF    PORTA,7
    BTFSS  RES1,7
    BCF    PORTA,7
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC15
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C15

    ENDIF

;PORTA

;CANAL14 LED13

    IFDEF   CANAL14_RET
    BTFSS  RES1,6
    GOTO   J3QZ           ;estava J3C1Q  
    BTFSC  FLAG_TOK14     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1QZ         ;estava J3Q
    BTFSC  PORTA,6     ;INVERTE CANAL 2 EM MODO RETENO
    GOTO   J2QZ
    BSF    PORTA,6
    BSF    TMP1X,6
    GOTO   J1QZ
J2QZ  BCF    PORTA,6
    BCF    TMP1X,6
J1QZ  BSF    FLAG_TOK14
J3C1QZ 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC14
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C14
J3QZ
    ELSE
    BTFSC  RES1,6     ;ACIONA CANAL 2 EM MODO PULSO
    BSF    PORTA,6
    BTFSS  RES1,6
    BCF    PORTA,6
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC14
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C14
    ENDIF
;CANAL13  LED12
    IFDEF   CANAL13_RET
    BTFSS  RES1,4
    GOTO   J3WQ  
    BTFSC  FLAG_TOK13     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1WQ

    BTFSC  PORTA,4     ;INVERTE CANAL 3 EM MODO RETENO
    GOTO   J2WQ
    BSF    PORTA,4
    BSF    TMP1X,4
    GOTO   J1WQ
J2WQ  BCF    PORTA,4
    BCF    TMP1X,4
J1WQ  BSF    FLAG_TOK13
J3C1WQ 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC13
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C13
J3WQ
    ELSE
    BTFSC  RES1,4     ;ACIONA CANAL 3 EM MODO PULSO
    BSF    PORTA,4
    BTFSS  RES1,4
    BCF    PORTA,4
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC13
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C13
    ENDIF
;CANAL12  LED11
    IFDEF   CANAL12_RET
    BTFSS  RES1,3
    GOTO   J3EW  
    BTFSC  FLAG_TOK12     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1EW
    BTFSC  PORTA,3     ;INVERTE CANAL 4 EM MODO RETENO
    GOTO   J2EW
    BSF    PORTA,3
    BSF    TMP1X,3  
    GOTO   J1EW
J2EW  BCF    PORTA,3
    BCF    TMP1X,3
J1EW  BSF    FLAG_TOK12
J3C1EW 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC12
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C12
J3EW
    ELSE
    BTFSC  RES1,3     ;ACIONA CANAL 4 EM MODO PULSO
    BSF    PORTA,3
    BTFSS  RES1,3
    BCF    PORTA,3
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC12
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C12
    ENDIF
;CANAL11  LED10
    IFDEF   CANAL11_RET
    BTFSS  RES1,2
    GOTO   J3RX  
    BTFSC  FLAG_TOK11     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1RX
    BTFSC  PORTA,2     ;INVERTE CANAL 5 EM MODO RETENO
    GOTO   J2RX
    BSF    PORTA,2
    BSF    TMP1X,2
    GOTO   J1RX
J2RX  BCF    PORTA,2
    BCF    TMP1X,2
J1RX  BSF    FLAG_TOK11
J3C1RX 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC11
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C11
J3RX
    ELSE
    BTFSC  RES1,2     ;ACIONA CANAL 5 EM MODO PULSO
    BSF    PORTA,2
    BTFSS  RES1,2
    BCF    PORTA,2
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC11
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C11
    ENDIF
 
;CANAL10   LED9
    IFDEF   CANAL10_RET
    BTFSS  RES1,1
    GOTO   J3TX  
    BTFSC  FLAG_TOK10     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1TX
    BTFSC  PORTA,1     ;INVERTE CANAL 6 EM MODO RETENO
    GOTO   J2TX
    BSF    PORTA,1
    BSF    TMP1X,1
    GOTO   J1TX
J2TX  BCF    PORTA,1
    BCF    TMP1X,1
J1TX  BSF    FLAG_TOK10
J3C1TX 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC10
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C10
J3TX
    ELSE
    BTFSC  RES1,1     ;ACIONA CANAL 6 EM MODO PULSO
    BSF    PORTA,1
    BTFSS  RES1,1
    BCF    PORTA,1
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC10
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C10
    ENDIF

;CANAL9   LED8
    IFDEF   CANAL9_RET
    BTFSS  RES1,0
    GOTO   J3YX  
    BTFSC  FLAG_TOK9     ;TESTA FLAG DE LIBERAO
    GOTO   J3C1YX
    BTFSC  PORTA,0     ;INVERTE CANAL 7 EM MODO RETENO
    GOTO   J2YX
    BSF    PORTA,0
    BSF    TMP1X,0
    GOTO   J1YX
J2YX  BCF    PORTA,0
    BCF    TMP1X,0
J1YX  BSF    FLAG_TOK9
J3C1YX 
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC9
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C9
J3YX
    ELSE
    BTFSC  RES1,0     ;ACIONA CANAL 7 EM MODO PULSO
    BSF    PORTA,0
    BTFSS  RES1,0
    BCF    PORTA,0
    MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO 
    MOVWF  NOTXC9
	MOVLW  VNOTX      ;RECARGA DO REGISTRADOR DE TX RECEBIDO
    MOVWF  NOTX1C9
    ENDIF




    MOVFW  TMPX        ;HOUVE MUDANA EM TMP1X?
    XORWF  TMP1X,W
    BTFSC  STATUS,Z
    GOTO   X83          ;NO, APENAS RETORNA

    MOVFW  TMP1X      ;SIM, ENTO SALVA NA EEPROM NO ENDEREO '0'
    MOVWF  TMPX
    MOVLW  .1
    CALL   EEWRITE
X83
    MOVFW  TMP        ;HOUVE MUDANA EM TMP1?
    XORWF  TMP1,W
    BTFSC  STATUS,Z
    RETURN           ;NO, APENAS RETORNA
    MOVFW  TMP1      ;SIM, ENTO SALVA NA EEPROM NO ENDEREO '0'
    MOVWF  TMP
    MOVLW  .0
    CALL   EEWRITE
    RETURN

;=========================================================================================================
;                              ESCREVER NA EEPROM INTERNA
;=========================================================================================================
EEWRITE
;endereo esta 'w'
;dado a escrever em TMP

   
	BANK1
	movwf EEADR	
	BANK0
	MOVFW  TMP		;PEGA PRIMEIRO DADO
	BANK1
	movwf EEDATA
	bcf EECON1, EEIF	
	bsf EECON1, WREN ; enable Write
	movlw 0x55	
	movwf EECON2	
	movlw 0xAA	
	movwf EECON2	
	bsf EECON1, WR	
	btfsc EECON1, WR ; Write complete ?
	goto $-1
	bcf EECON1, WREN ; disable Write
 	BANK0
    RETURN
;=========================================================================================================
;                              LER A EEPROM INTERNA
;=========================================================================================================

EEREAD
;endereo esta 'w';retorna dado em 'w'
	BANK1
	movwf EEADR	
	bsf EECON1, RD ; do a read\par
	btfsc EECON1, RD ; Read done ?\par
	goto $-1	
	movf EEDATA,W
	BANK0
	RETURN


   ORG 0X2100
   DE .0,.0
;===========================================================================================================
;                       FIM DO PROGRAMA
;===========================================================================================================
     end
